#include "p24Fxxxx.h"
#include "GenericTypeDefs.h"
#include "stdio.h"
#include "system.h"

#include "TFT_24.h"
#include "libpic30.h"
#include "string.h"



void TFT_wr_data(UINT16 data)
{
  TFT_RS = 1;
  TFT_PORT = data;
  TFT_WR = 0;
  TFT_WR = 1;
}

//-------------------------------------------------------

void TFT_wr_cmd(UINT16 data)
{
  TFT_RS = 0;
  TFT_PORT = data;
  TFT_WR = 0;
  TFT_WR = 1;
}

//-------------------------------------------------------

void TFT_Address_set(uint x1, uint y1, uint x2, uint y2)
{
  TFT_wr_cmd(0x2a);
  TFT_wr_data(x1>>8);
  TFT_wr_data(x1);
  TFT_wr_data(x2>>8);
  TFT_wr_data(x2);
  TFT_wr_cmd(0x2b);
  TFT_wr_data(y1>>8);
  TFT_wr_data(y1);
  TFT_wr_data(y2>>8);
  TFT_wr_data(y2);
  TFT_wr_cmd(0x2c);
}

//-------------------------------------------------------

void TFT_clear(void)
{
  TFT_box(0,0,DISPLAY_W,DISPLAY_H,wt);
}

//-------------------------------------------------------

void TFT_box(UINT16 x1,UINT16 y1,UINT16 x2,UINT16 y2,UINT16 color)
{
  UINT16 x,y;
  if ((x1 < DISPLAY_W) && (y1 < DISPLAY_H) && (x1 <= x2) && (y1 <= y2))
  {
    if (x2 >= DISPLAY_W)
      x2 = DISPLAY_W-1;
    if (y2 >= DISPLAY_H)
      y2 = DISPLAY_H;

    TFT_CS = 0;
    TFT_Address_set(x1,y1,x2,y2);
    for (x=x1;x <= x2;x++)
      for (y=y1;y <= y2;y++)
        TFT_wr_data(color);
    TFT_CS = 1;
  }
}

//-------------------------------------------------------

void TFT_pset(UINT16 x,UINT16 y,UINT16 color)
{
  if ((x < DISPLAY_W) && (y < DISPLAY_H))
  {

    TFT_CS = 0;
    TFT_Address_set(x,y,x,y);
    TFT_wr_data(color);
    TFT_CS = 1;
  }
}

//-------------------------------------------------------

void TFT_init(void)
{
  TFT_PORT_TRIS = 0;
  TFT_RESET_Out();
  TFT_RESET = 1;
  LED_R = 0;
  __delay_ms(50);
  TFT_BL_Out();
  TFT_BL = 1;

  TFT_CS = 1;
  TFT_RD = 1;
  TFT_WR = 1;
  TFT_RS_Out();
  TFT_CS_Out();
  TFT_RD_Out();
  TFT_WR_Out();
  TFT_RESET = 0;
  __delay_ms(10);
  TFT_RESET = 1;
  __delay_ms(5);
  TFT_CS = 0;

  TFT_wr_cmd(0xE9);
  TFT_wr_data(0x20);

  TFT_wr_cmd(0x11);     //Exit Sleep
  __delay_ms(100);

  TFT_wr_cmd(0xD0);     //VCOM Control
  TFT_wr_data(0x07);
  TFT_wr_data(0x01);
  TFT_wr_data(0x04);

  TFT_wr_cmd(0xD1);     //Power_Setting
  TFT_wr_data(0x00);
  TFT_wr_data(0x58);    //59  VCOH
  TFT_wr_data(0x15);    //15 VCOM AP

  TFT_wr_cmd(0x36);     //Set_address_mode
  TFT_wr_data(0x48);

  TFT_wr_cmd(0xC1);     //Display_Timing_Setting for Normal/Partial Mode
  TFT_wr_data(0x10);
  TFT_wr_data(0x10);
  TFT_wr_data(0x02);
  TFT_wr_data(0x02);

  TFT_wr_cmd(0xC0);     //Panel Driving Setting
  TFT_wr_data(0x00);
  TFT_wr_data(0x35);
  TFT_wr_data(0x00);
  TFT_wr_data(0x00);
  TFT_wr_data(0x01);
  TFT_wr_data(0x02);

  TFT_wr_cmd(0xC5);     //Frame Rate Control
  TFT_wr_data(0x04);

  TFT_wr_cmd(0xD2);     //Power_Setting for Normal Mode
  TFT_wr_data(0x01);
  TFT_wr_data(0x44);

  TFT_wr_cmd(0xC8);     //SET GAMMA
  TFT_wr_data(0x04);
  TFT_wr_data(0x67);
  TFT_wr_data(0x35);
  TFT_wr_data(0x04);
  TFT_wr_data(0x08);
  TFT_wr_data(0x06);
  TFT_wr_data(0x24);
  TFT_wr_data(0x01);
  TFT_wr_data(0x37);
  TFT_wr_data(0x40);
  TFT_wr_data(0x03);
  TFT_wr_data(0x10);
  TFT_wr_data(0x08);
  TFT_wr_data(0x80);
  TFT_wr_data(0x00);

  TFT_wr_cmd(0x3A);     //Set_pixel_format (16bit/pixel)
  TFT_wr_data(0x55);

  TFT_wr_cmd(0xB3);     //Frame Memory Access and Interface Setting
  TFT_wr_data(0x02);
  TFT_wr_data(0x00);
  TFT_wr_data(0x00);
  TFT_wr_data(0x30);

  TFT_wr_cmd(0x2A);     //Frame rate control
  TFT_wr_data(0x00);
  TFT_wr_data(0x00);
  TFT_wr_data(0x00);
  TFT_wr_data(0xEF);

  TFT_wr_cmd(0x2B);     //Display function control
  TFT_wr_data(0x00);
  TFT_wr_data(0x00);
  TFT_wr_data(0x01);
  TFT_wr_data(0x8F);

  TFT_wr_cmd(0x29);     //DISPLAY ON

  TFT_CS = 1;
}


