#ifndef TFT_24_H
#define TFT_24_H

#define TFT_PORT          LATB
#define TFT_PORT_TRIS     TRISB
#define	TFT_RESET_Out()   TRISCbits.TRISC9 = OUTPUT_PIN
#define	TFT_RESET         LATCbits.LATC9
#define	TFT_RD_Out()	  TRISAbits.TRISA1 = OUTPUT_PIN
#define	TFT_RD            LATAbits.LATA1
#define	TFT_CS_Out()      TRISAbits.TRISA7 = OUTPUT_PIN
#define	TFT_CS            LATAbits.LATA7
#define	TFT_RS_Out()      TRISAbits.TRISA8 = OUTPUT_PIN
#define	TFT_RS            LATAbits.LATA8
#define	TFT_WR_Out()      TRISAbits.TRISA0 = OUTPUT_PIN
#define	TFT_WR            LATAbits.LATA0
#define	TFT_BL_Out()      TRISAbits.TRISA4 = OUTPUT_PIN
#define	TFT_BL            LATAbits.LATA4

#define DISPLAY_W         240
#define DISPLAY_H         400

#define wt 0xffff
#define rd 0xf800
#define gn 0x07e0
#define bl 0x001f
#define ye 0xffe0
#define mg 0xf81f
#define cy 0x07ff
#define bk 0x0000

void TFT_init(void);
void TFT_wr_cmd(UINT16);
void TFT_wr_dat(UINT16);
void TFT_pset(UINT16,UINT16,UINT16);
void TFT_clear(void);
void TFT_box(UINT16,UINT16,UINT16,UINT16,UINT16);


#endif   // TFT_24_H
